// Copyright (C) 1998 Kazuhisa Iizuka

import java.util.*;

public class ArgsManager {
  private Vector args;
  private TagManager tags;

  public ArgsManager() {
    this(new TagManager());
  }

  public ArgsManager(TagManager tags) {
    args = new Vector();
    this.tags = tags;
  }

  public synchronized RetObject newObject() {
    RetObject obj = new RetObject(tags.newTag());
    args.addElement(obj);
    return obj;
  }

  public synchronized void setData(Data obj, int tag) {
    for (int i = 0; i < args.size(); i++) {
      RetObject element = (RetObject)args.elementAt(i);
      if (element.tag == tag) {
	element.write(obj);
	args.removeElementAt(i);  // ǡꥹȤ鳰
	tags.deleteTag(element.tag);   // ѤƤ᤹
      }
    }
  }
}
