// Copyright (C) 1998 Kazuhisa Iizuka

import java.net.*;
import java.io.*;
import java.util.*;
import java.text.*;

public class Sleep {
  public static void main(String args[]) {
    int port = 9007;

    if (args.length == 1) {
      try {
	port = Integer.parseInt(args[0]);
      } catch (java.lang.NumberFormatException nfe) {
	System.err.println("usage : java Sleep [<port>]");
	System.exit(1);
      }
    }

    try {
      ServerSocket servSock = new ServerSocket(port);

      for (;;) {
	System.out.print("accepting...");
	Socket sock = servSock.accept();
	System.out.println("connect to " + sock.getInetAddress() + "\n");

	InputStream in = sock.getInputStream();
	OutputStream out = sock.getOutputStream();
	out.write(10);  // test message
	new JK(in, out);
      }
    } catch (Exception e) {
      System.err.println("Exception :" + e);
    }
  }

  public static Data sleep(Data time) {
    int sec = time.getInteger();
    try {
      Thread.sleep(sec * 1000);
    } catch(InterruptedException e) {
    }
    return Data.String(DateFormat.getDateTimeInstance().format(new Date()));
  }
}
